// This simple program tests a StringList class.  The user gets to choose preset test 
// cases or type in their own list of strings.
// The program then calls methods of the StringList class, so that results can be seen.

// written by Scott McElfresh  

import java.io.*;

public class StringListTester 
{
	public static void main(String[] args) throws IOException
	{
       InputStreamReader input = new InputStreamReader(System.in);
       BufferedReader keyboard = new BufferedReader(input);
       
       StringList userlist = null;  // no object yet to track the list
       
       int numtestcases = 6;
       
  int whichTestCase = -9;
  while (whichTestCase != 0)
  {
       System.out.println("---------------------------------------------------------");
       System.out.println("Which test case do you want? 1 .. " + numtestcases);
       System.out.println("Enter " + (numtestcases + 1) + " to enter your own words. ");
       System.out.println("Enter 0 to quit.");
       System.out.print("----> ");
       String answer = keyboard.readLine();
       whichTestCase = Integer.parseInt(answer);
       if (whichTestCase == 0)
           return;  // exit the main function
       if (whichTestCase == 1)
       {
          userlist = new StringList(); // a list object tracking no items yet
          userlist.insert("Scott");
          userlist.insert("Sarah");
          userlist.insert("Katie");
          userlist.insert("McElfresh");
       }
       if (whichTestCase == 2)
       {
          userlist = new StringList(); // a list object tracking no items yet
          userlist.insert("McElfresh");
          userlist.insert("Scott");
          userlist.insert("Sarah");
          userlist.insert("Katie");
       }
       if (whichTestCase == 3)
       {
          userlist = new StringList(); // a list object tracking no items yet
          userlist.insert("Scott");
          userlist.insert("McElfresh");
          userlist.insert("Sarah");
          userlist.insert("Katie");
       }       
       if (whichTestCase == 4)
       {
          userlist = new StringList(); // a list object tracking no items yet
          userlist.insert("mom");
          userlist.insert("dad");
          userlist.insert("apple");
          userlist.insert("pie");
          userlist.insert("MOM");
          userlist.insert("DAD");
          userlist.insert("APPLE");
          userlist.insert("PIE");
          userlist.insert("Mom");
          userlist.insert("Dad");
          userlist.insert("Apple");
          userlist.insert("Pie");
       }
       if (whichTestCase == 5)
       {
          String mother =  new String("mom");
          userlist = new StringList(4); // a list object tracking no items yet, but CAN track 4
          userlist.insert(mother);
          userlist.insert("dad");
          userlist.insert("apple");
          userlist.insert("pie");
       }
       if (whichTestCase == 6)
       {
          userlist = new StringList();   // a list object tracking no items yet
          System.out.println("----- This test case is an empty list. -------");
       }
       
       if (whichTestCase > numtestcases)
       {  
          userlist = new StringList();
          System.out.println("You have chosen to enter your own test case.  Just hit enter/return when you are done.");
          String thisone;  // what the user will enter
          do 
          {
             System.out.print("Enter a string: ");
             thisone = keyboard.readLine();
             if (thisone.length() != 0)
                 userlist.insert(thisone);         
          }  while (thisone.length()!=0);
       }
       
       System.out.println("Here are the " + userlist.getHowMany() + " strings: ");
       userlist.displayAll();
      /*
       System.out.println("**** PART 1 *******");
       System.out.println("Here are the strings again: ");
       for (int i = 0; i < userlist.getHowMany(); i++)
           System.out.print(userlist.getStringAt(i) + ",");  
       System.out.println();
      */
      /*
       System.out.println("**** PART 2 *******");
       
       
       System.out.println("Here are the strings in the opposite order: ");
       userlist.displayBackwards();
      */
      /*
       System.out.println("**** PART 3 *******");      
       System.out.println("Here are the strings, each of them backwards: ");
       userlist.displayEachBackwards();
      */
      /*
       System.out.println("**** PART 4 *******");
       
       System.out.println("There are a total of : " + userlist.totalChars() + " characters.");
      */
      /*
       System.out.println("**** PART 5 *******");    


       System.out.println("Here are the " + userlist.countHowManyStartEndSame() + 
                                  " strings that start and end with the same character:");
       userlist.startAndEndSame();
      */
      /*
       System.out.println("**** PART 6 *******"); 
       
       System.out.println("Here are the " + userlist.countVowelEndings() + " strings that end in a vowel");
       userlist.displayEndinginVowel();
      */
      /*
       System.out.println("**** PART 7 *******");
       
       System.out.println("There are a total of : " + userlist.totalChars() + " characters.");

      */
      /*
       System.out.println("**** PART 8 *******");
       for (int i = 0; i <userlist.getHowMany() ; i ++)
       {
           String searchword = userlist.getStringAt(i);
           if (! userlist.contains(searchword))
         		System.out.println("ERROR! " + searchword + " was NOT found in the list.  ERROR!");
       }
       
       if (userlist.contains("SpringBreak"))
         System.out.println("SpringBreak was found in the list.");
       else
         System.out.println("SpringBreak was not found in the list.");
       if (userlist.contains("sleep"))
         System.out.println("sleep was found in the list.");
       else
         System.out.println("sleep was not found in the list.");
         
      */
      /*
       System.out.println("**** PART 9 *******");
       System.out.println("The longest string is : " + userlist.longestString());
      */

       for (int countblanklines = 0; countblanklines < 5; countblanklines ++)
             System.out.println();
     
   }  // end of while loop
       
    }
	

}
